unit Q_GIF;

{$i-}

{  uzywanie obrazkow GIF, troche wolne ale zawsze skuteczne!

   (C) 1993 UHO SOFTWARE Lukasz Knasiecki
   kontakt:ul.Spasowskiego 7c/5 Koszalin
   kopiowanie bez zgody autora zabronione!

   bledy GIFERROR: 1-to nie gif
                   2-blad przy czytaniu headera
                   3-plik uszkodzony [wewnetrznie]
                   4-blad dyskowy
                   5-za duzy obrazek}


interface
uses crt,dos,q_types;

const bigbuflen=32000;

var gifERROR:byte;
    gifCheck:boolean;

procedure load_gif (nazwa:string;var dane:obrwsk; var p:bpt;
                                   var ilepal:word;how,mem:boolean);
{laduje gifa NAZWA do DANE, paleta do P, ile wart.palety do ILEPAL,
 GIFERROR wiadomo, HOW-jak skrocic obrazek gdy za duzy:2 mozliwosci,
 MEM-czy przydzielic pamiec?}

procedure move_gif ( var GIFplik:file;
                     var dane:obrwsk; var p:bpt;
                     var ilepal:word;how,mem:boolean;
                     ishead:boolean);

implementation

type bufttt  = ^buftyp;
     buftyp  =  array[0..$FFFF-1] of byte;

procedure haltix(nr:byte);
begin
 textmode(C80);
 writeln('Error while reading file #',nr);
 halt;
end;

var {GifPlik:file;}
    gifCodeSize,gifTYP:byte;
    dane:obrwsk;
    gifEnd,interlace,GifTheEnd:boolean;
    gifX,gifY:word;

{klasa inBuffer}

       bitOffset:longint;
       curlen:word;
       mask:array[0..15] of word;

{klasa LZWdecode}

       lzw_start_len,lzw_max_len,lzw_cur_len,buflen:byte;
       lzw_clear,lzw_eoi,lzw_first,lzw_code,lzw_max_code,lzw_this_max:word;
       jammed,bufPTR,table_size:integer;

       new_code,old_code,character:word;
       codetable:array[0..4096*2] of word;
       buffer:bufttt;
       lzbuf:array[0..1024] of word;
       end_of_codes:byte;

procedure move_gif;

procedure LZW_konstruktor(start,endek:integer);
var i:word;
begin

 lzw_start_len:=start;
 lzw_cur_len  :=start;
 lzw_clear    :=(1 shl (lzw_start_len -1));
 lzw_eoi      :=lzw_clear+1;
 lzw_first    :=lzw_clear+2;
 lzw_code     :=lzw_clear+2;
 lzw_max_code :=(1 shl endek) -1;
 lzw_this_max :=lzw_clear shl 1;
 jammed       :=-1;
 bufptr       :=-1;
 old_code     :=$ffff;
 table_size   :=lzw_max_code+1;

 for i:=0 to Table_size do
 begin
  codetable[i]:=0;
  codetable[i+table_size]:=0;
 end;

 if endek>12 then endek:=12;
 lzw_max_len:=endek;

end;
{---------------------------------------------------------------}

procedure LZW_decode(code:integer);
begin

 jammed:=-1;
 while(code>=lzw_first) do
 BEGIN

  inc(bufptr);
  lzbuf[bufptr] :=codetable[code+table_size];
  code          :=codetable[code];

  if bufptr=1023 then
  begin
   jammed:=code;                                {jesli bufor przepelniony}
   exit;
  end;

 END;

 inc(bufptr);
 lzbuf[bufptr]:=code;

END;

{---------------------------------------------------------------}
procedure getBlock;
var a,b:word;
begin

 b:=bitoffset div 8;
 a:=curlen-b;
 if a>0 then move(buffer^[b],buffer^[0],5);
 bitOffset:=bitOffset mod 8;
  REPEAT
   blockread(GifPlik,buflen,1);
   if buflen<>0 then
    begin
     blockread(GifPlik,buffer^[a],buflen);
     inc(a,buflen);
    end else gifEnd:=true;
  UNTIL (a+256>=bigBufLen) or gifEnd or eof(GIFplik);
 curlen:=a;
 if doserror+ioresult<>0 then haltix(4);
  {begin gifError:=4; GiftheEnd:=true; exit; end;}

end;

{---------------------------------------------------------------}
function getNextCode(len:byte):word;

Var RawCode:LongInt;
    A:Word;
    byteOffset:word;
Begin
     ByteOffset:=BitOffset div 8;
{     a:=buffer^[byteoffset]+256*buffer^[byteoffset+1];}
     a:=buffer^[byteoffset] or (buffer^[byteoffset+1] shl 8);

     If Len>=8 then
     Begin
      RawCode:=a+65536*buffer^[byteoffset+2];
     End else rawcode:=a;

     RawCode:=RawCode shr (BitOffset mod 8);
     GetNextCode:=RawCode and Mask[len];

     inc(BitOffset,Len);
     if not Gifend and (byteOffset+4>=curlen) then getBlock else
     if gifend and (bitOffset div 8=curlen) then gifTheEnd:=true;

End;

{---------------------------------------------------------------}

function LZW_getnext :word;
var i:integer;
begin

 if bufptr>-1 then
 begin
  lzw_getnext:=lzbuf[bufptr];                  {jesli bufor nie pusty-oproznij go}
  dec(bufptr);
  exit;
 end;

 if jammed>-1 then
 begin
  LZW_decode(jammed);      {jesli cos trza jeszcze wpisac do bufora->wpisz}
  lzw_getnext:=lzbuf[bufptr];
  dec(bufptr);
  exit;
 end;


 {----------dekodowanie nast.kodu---------------}

 new_code:=getNextCode(LZW_cur_LEN);

 if new_code<>lzw_eoi then
 BEGIN

 {----------jesli to kod clear----}

  if new_code=lzw_clear then
  BEGIN
   for i:=0 to lzw_max_code do
   begin
    codetable[i]:=0;
    codetable[i+table_size]:=0;
   end;

   lzw_code     :=lzw_first;
   lzw_cur_len  :=lzw_start_len;
   lzw_this_max :=lzw_clear shl 1;
   character    :=getNextCode(lzw_cur_len);
   old_code     :=character;
   lzw_getnext  :=old_code;
   exit;
  END

  else

 {----------jesli to nie clear----}

  BEGIN

   if new_code=lzw_code then
   begin
    inc(bufptr);
    lzbuf[bufptr]:=character;
    lzw_decode(old_code);
   end

   else

   if new_code>lzw_code then haltix(3)
{   begin
    gifError:=3; gifTheEnd:=true; exit;
   end}

   else
    lzw_decode(new_code);

   lzw_getnext :=lzbuf[bufptr];
   character   :=lzbuf[bufptr];
   dec(bufptr);

   IF LZW_code <= lzw_max_code then
   BEGIN

    codetable[lzw_code]:=old_code;
    codetable[lzw_code+table_size]:=character;
    inc(lzw_code);

    if (lzw_code=lzw_this_max) and (lzw_cur_len<lzw_max_len) then
    begin
     inc(lzw_cur_len);
     lzw_this_max:=lzw_this_max shl 1;
    end;

   end;

   old_code:=new_code;
   exit;

  END;

 END

 else ;

END;

{---------------------------------------------------------------}

procedure inBuffer_konstruktor;
var i,m:word;
begin

 m:=0;

 for i:=1 to 15 do
 begin
  m:=(m shl 1)+1;
  mask[i]:=m;
 end;

 end_of_codes:=0;
 curlen      :=0;
 bitOffset   :=0;
 gifEnd:=false;
 gifTheEnd:=false;
 getblock;

end;

{---------------------------------------------------------------}
procedure GetGifHeader(var p:bpt);
type GifHeader1=record
                      rwidht,rheight:word;
                      colormap,Gifbckg,H1skip:byte;
                     end;
     GifHeader2=record
                      H2skip:byte;
                      leftOfs,TopOfs:word;
                      XX,YY:word;
                      interlace,codesize:byte;
                     end;
var s:string;
    h1:gifheader1;
    h2:gifheader2;
    colormap:boolean;
    i,colorMapSize:word;
begin

     if isHead then
     begin
      blockread(gifPlik,s[1],6);
      s[0]:=chr(6);
      If (s<>'GIF87a') and GifCheck then haltix(1);{begin gifError:=1; exit; end;}
     end;

     blockread(Gifplik,h1,sizeof(h1));

     If h1.colormap and $80=$80 then Colormap:=True else Colormap:=False;
     { Resolution  :=B and $70 shr 5 +1; unused}

     gifTYP:=h1.colormap and 7 +1;                    {bits per pixel}
     ColorMapSize:=1 shl gifTyp;

     If gifTyp=1 then gifTyp:=2 else I:=1 shl gifTYP;

     If Colormap then
     begin
      blockread(GifPlik,p,colorMapSize*3);   {paletka}
       for i:=0 to colorMapSize-1 do
       with p[i] do
       begin
        red:=red div 4;
        green:=green div 4;
        blue:=blue div 4;
       end;
     end;

     blockread(GIFplik,h2,sizeof(h2));
     If h2.interlace and $40=$40 then Interlace:=True else Interlace:=False;
     GIFcodesize:=h2.codesize;
     gifX:=h2.xx;
     gifY:=h2.yy;
end;
{---------------------------------------------------------------}

var a,c,x,y,picx:word;
    i:longint;
    xtab,ytab:array[1..1024] of boolean;
    ywax:array[1..1024] of byte;
    pass:byte;
    r,r1:real;
begin

 a:=ioresult;
 doserror:=0;
 gifError:=0;
 getGifHeader(p);

 if doserror+ioresult<>0 then haltix(2); {begin gifError:=2; exit; end;}
 if (gifx>1024) or (gify>1024) then haltix(5); {begin giferror:=5; exit; end;}

 if gifx>320 then x:=320 else x:=gifx;
 if gify>200 then y:=200 else y:=gify;
 if mem then getmem(dane,X*Y+20);
 getmem(buffer,bigBufLen+50);
 fillchar(dane^,x*y+6,0);

 inBuffer_konstruktor;
 lzw_konstruktor(gifCodeSize+1,12);

  if how then
  BEGIN
   for a:=1 to 1024 do
   begin
    xtab[a]:=false;
    ytab[a]:=false;
   end;

   r:=gifX/320; r1:=1;
    for a:=1 to 320 do
    begin
     xtab[trunc(r1)]:=true;
     r1:=r1+r;
    end;

   r:=gifY/200; r1:=1;
    for a:=1 to 200 do
    begin
     ytab[trunc(r1)]:=true;
     r1:=r1+r;
    end;
    c:=0;
    if interlace then
    for a:=1 to gifY do
    begin
     ywax[a]:=c;
     if ytab[a] then inc(c);
    end;

  END;

 i:=0; x:=0; y:=0;
 pass:=0;
 if not how and (gifY>200) then gifY:=200;
 if gifx>320 then picx:=320 else picx:=gifx;

 REPEAT
  c:=lzw_getnext;
  if not how and (x<320) then
   begin dane^[6+i]:=c; inc(i); end
  else if how and xtab[x+1] and ytab[y+1] then
   begin dane^[6+i]:=c; inc(i); end;

  inc(x);
  if x=gifx then
  begin
   x:=0;
   if not interlace then
   begin
    inc(y);
    if y=gifY then gifTheEnd:=true;
   end
     else Begin
               Case Pass of
               0: Begin
                  Y:=Y+8;
                  If Y>=gifY then
                  Begin
                     inc(pass);
                     Y:=4;
                  End;
                  End;
               1: Begin
                  Y:=Y+8;
                  If Y>=gifY then
                     Begin
                       inc(pass);
                       Y:=2;
                     End;
                  End;
               2: Begin
                  Y:=Y+4;
                  If Y>=gifY then
                     Begin
                          Pass:=Succ(Pass);
                          Y:=1;
                     End;
                  End;
               3: Begin
                   Y:=Y+2;
                   if y>gifY then gifTheEnd:=true;
                  End;
               End;    {Case}
             i:=picX*ywax[y+1];
            End;  {If interlace}
  end;
 UNTIL gifTheEnd ;

 if gify>200 then gify:=200;
 dane^[1]:=gifX mod 256;
 dane^[2]:=gifX div 256;
 dane^[3]:=gifY mod 256;
 dane^[4]:=0;
 release(buffer);

end;

procedure load_gif;
var a:byte;
    plik:file;
begin
 a:=ioresult;
 doserror:=0;
 gifError:=0;
 assign(Plik,nazwa);
 reset(Plik,1);
 if ioresult+doserror<>0 then haltix(4); {begin GifError:=4; exit; end;}
 move_gif ( plik,dane,p,ilepal,how,mem,true);
 close(plik);
end;

end.

