unit q_types;

{  tu zawarte sa wszystkie podstawowe typy uzywane w modulach UHO

   podstawowy typ: OBRWSK jest uzywany wszedzie jako dynamiczny przechowywacz
   danych, obsluga np:

    var d:obrwsk;
     getmem(d,10000); przydzial pamieci
     d^[3]:=4;      ; przyklad  przypisania
     release(d)     ; zwolnienie pamieci

   UWAGA!
   obrazki 256-kolorowe przechowywane sa nastepujaco:
    bajt 1,2 : X
    bajt 3,4 : Y
    bajt 5   : none
    bajt 6...: dane po kolei liniami poziomymi

   (C) 1993 UHO SOFTWARE Lukasz Knasiecki
   kontakt:ul.Spasowskiego 7c/5 Koszalin
   kopiowanie bez zgody autora zabronione!
   brak kontroli bledow - uwazac!}

interface
uses crt;

 const mcol=15;                         {kolor kursora myszki}
 type s20=string[20];                   {typki tekstowe...}
      s40=string[40];
      s80=string[80];
      sob=set of byte;
      txt_array= array[1..64] of s20;

 type obrwsk  = ^obrazek;                   {PODSTAWOWY TYP!}
      obrazek =  array[1..$FFFF] of byte;
      roz_uhf = array[0..$FF] of word; {typ rozkladu fontow UHF}
      colchange = array [0..20] of record   {do modulu f_graph}
                                    o,n :byte;
                                  end;

 {graph 256 unit}
 type  PaletteRec        = record
                             red,green,blue : byte;
                           end;
       rgbrec            = paletterec;
       BlockPaletteType  = Array[0..255] of PaletteRec;
       BPT               = BlockPaletteType;

 {palette unit}
     pal_off_typ = array[1..100] of byte;
     SamRec=record
             dane:obrwsk;
             Size:word;
             Rate:word;
             W   :word;
            end;
     SampleInfo= record
                  ref:pointer;
                  Size,Freq:word;
                 end;

 var marmur:obrwsk;

procedure haltix(s:string);
procedure wymiary (var x,y :word;var dane : obrwsk);
 {podaje wymiary obrazka DANE x,y}

implementation

procedure wymiary (var x,y :word;var dane : obrwsk);

begin

 x:=dane^[1]+256*dane^[2];
 y:=dane^[3];

end;

function IX (var shit:obrwsk):word;
begin
 ix:=shit^[1]+256*shit^[2];
end;

function IY (var shit:obrwsk):word;
begin
 iy:=shit^[3]+256*shit^[4];
end;

procedure haltix;
begin
 {vga on}
 asm
  push ax
  push bx
  mov ax,1200h
  mov bl,32h
  int 10h
  pop bx
  pop ax
 end;
 textmode(c80);
 writeln('Error > ',s);
 halt;
end;

end.
