unit q_basics;

interface

uses crt,dos,q_types;

procedure haltix(s:string);
procedure waitsync;
function wReadkey:word;
procedure mark_time(var czas:longint);
function minus_time(old:longint) :longint;
procedure mark_time2(var czas:word);
function minus_time2(old:word) :word;
function spaces(ile:byte):string;
function klik:byte;
procedure txt_sorter (var txt:txt_array;ile:byte);
procedure clsError;
function isError:boolean;
procedure memWarning(kb:word);
procedure Tkursor (jest:boolean);
procedure TakeKeyPress;
{--tekstowe---}
function posLeft(var s:string;i:byte;ch:char):byte;
function posRight(var s:string;i:byte;ch:char):byte;
procedure stringer(var s:string);
procedure dataString(var s:String);
procedure zamien_str(var s:string;s1,s2:string);
function str2(w:word):string;
procedure eliminuj_str(var s:string;s1:string);

IMPLEMENTATION

procedure mark_time(var czas:longint);
var h,m,s,s100:word;
    a1,a2,a3,a4:longint;
begin
 gettime(h,m,s,s100); a1:=h; a2:=m; a3:=s; a4:=s100;
 czas:=a1*60*60*100+a2*60*100+a3*100+a4;
end;

function minus_time(old:longint) :longint;
var a:longint;

begin

 mark_time(a);
 if old>a then minus_time:=old+(24*60*60*100)-a else
 minus_time:=a-old;

end;

procedure mark_time2(var czas:word);
var h,m,s,s100:word;
    a1,a2,a3,a4:longint;
begin
 gettime(h,m,s,s100); a1:=h; a2:=m; a3:=s; a4:=s100;
 czas:=a1*60*60+a2*60+a3;
end;

function minus_time2(old:word) :word;
var a:word;

begin

 mark_time2(a);
 if old>a then minus_time2:=old+(24*60*60)-a else
 minus_time2:=a-old;

end;


function spaces(ile:byte):string;
var s:string;
    a:byte;
begin

 s:='';
 if ile>0 then for a:=1 to ile do s:=s+' ';
 s[0]:=chr(ile);
 spaces:=s;
end;


function klik:byte;
begin
 klik:=ord(readkey);
end;

procedure txt_sorter (var txt:txt_array;ile:byte);
var akt,a,b,best:byte;
    main:txt_array;
begin

 main:=txt;
 akt:=0;

 for a:=1 to ile do
 begin
  best:=1;
   for b:=1 to ile do
     if main[b]<main[best] then best:=b;
   inc(akt);
   txt[akt]:=main[best];
  main[best]:=chr(244);
 end;

end;

procedure clsError;
begin
 doserror:=0;
 if ioresult=1 then ;
end;

function isError:boolean;
begin
 if doserror+ioresult<>0 then isError:=true else isError:=false;
end;

procedure memWarning(kb:word);
begin
 if (memavail div 1000)<kb then
 begin
  clrscr;
  writeln;
  writeln('UWAGA! MASZ ZA MALO PAMIECI! POTRZEBA JESZCZE ',
   kb-(memavail div 1000),' KB');
  writeln;
  writeln('usun wszystkie programy rezydentne albo utworz dysk startowy...');
  halt(4);
 end;
end;

procedure Tkursor (jest:boolean);
var rejestry :registers;
    pocz,kon:byte;
begin
if jest then begin pocz:=14; kon:=13 end else begin pocz:=0;kon:=0 end;
rejestry.ax:= $0100;
if jest then rejestry.cx:=pocz+256*kon
else rejestry.cx:=$2000;
intr(16,rejestry)
end;

function wReadkey:word;
var w:word;
begin
 w:=ord(upcase(readkey)); if w=0 then w:=256+ord(upcase(readkey));
 wreadkey:=w;
end;

procedure TakeKeyPress;
var ch:char;
begin
 while keypressed do ch:=readkey;
end;

function posLeft(var s:string;i:byte;ch:char):byte;
begin
 if i>0 then dec(i);
 while (i>1) and (s[i]=ch) do dec(i);
 while (i>1) and (s[i]<>ch) do dec(i);
 if (i>0) and (s[i]=ch) then inc(i);
 posLeft:=i;
end;

function posRight(var s:string;i:byte;ch:char):byte;
begin
 while (i<=length(s)) and (s[i]<>ch) do inc(i);
 while (i<=length(s)) and (s[i]=ch)  do inc(i);
 posRight:=i;
end;

procedure stringer(var s:string);
var a:byte;
begin
 while (s<>'') and (s[1]=' ') do delete(s,1,1);
 while (s<>'') and (s[length(s)]=' ') do s[0]:=chr(length(s)-1);
 zamien_str(s,'  ',' ');
end;

procedure dataString(var s:String);
var s1:s20;
    a1,a2,a3,a:word;
begin
 getdate(a3,a2,a1,a);
 str(a1:2,s1); if s1[1]=' ' then s1[1]:='0'; s:=s1+'-';
 str(a2:2,s1); if s1[1]=' ' then s1[1]:='0'; s:=s+s1+'-';
 str(a3:2,s1); if s1[1]=' ' then s1[1]:='0'; s:=s+s1;
end;

procedure eliminuj_str(var s:string;s1:string);
var a:byte;
begin
 repeat
  a:=pos(s1,s); if a>0 then delete(s,a,length(s1));
 until a=0;
end;

procedure zamien_str(var s:string;s1,s2:string);
var a:byte;
begin
 repeat a:=pos(s1,s);
        if a>0 then begin delete(s,a,length(s1)); insert(s2,s,a); end;
 until a=0;
end;

function str2(w:word):string;
var s:string;
begin
 str(w,s); str2:=s;
end;
{----------------------------------}
procedure waitsync; assembler;
asm
        mov dx,3dah
@WScome:
	in al,dx
	and al,8
	jnz @WScome
@WXcome:
	in al,dx
	and al,8
	jz @WXcome
end;
{----------------------------------}
procedure haltix(s:string);
begin
 textmode(co80);
 writeln('ERROR >',s);
 halt(100);
end;

end.
